'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _webpack = require('webpack');

var _webpack2 = _interopRequireDefault(_webpack);

var _webpackSources = require('webpack-sources');

var _webpackSources2 = _interopRequireDefault(_webpackSources);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var hotLoader = _path2.default.resolve(__dirname, './hotLoader.js');

var ConcatSource = _webpackSources2.default.ConcatSource,
    SourceMapSource = _webpackSources2.default.SourceMapSource,
    OriginalSource = _webpackSources2.default.OriginalSource;
var Template = _webpack2.default.Template,
    createHash = _webpack2.default.util.createHash;


var MODULE_TYPE = 'css/extract-chunks';

var pluginName = 'extract-css-chunks-webpack-plugin';

var REGEXP_CHUNKHASH = /\[chunkhash(?::(\d+))?\]/i;
var REGEXP_CONTENTHASH = /\[contenthash(?::(\d+))?\]/i;
var REGEXP_NAME = /\[name\]/i;

var isHMR = function isHMR(compiler) {
    if (compiler && compiler.options) {
        if (compiler.options.devServer && compiler.options.devServer.hot) {
            return true;
        }

        if (compiler.options.entry) {
            var entry = typeof compiler.options.entry === 'function' ? compiler.options.entry() : compiler.options.entry;
            var entryString = JSON.stringify(entry);
            return entryString.includes('hot') || entryString.includes('hmr');
        }
    }
    return false;
};

var CssDependency = function (_webpack$Dependency) {
    _inherits(CssDependency, _webpack$Dependency);

    function CssDependency(_ref, context, identifierIndex) {
        var identifier = _ref.identifier,
            content = _ref.content,
            media = _ref.media,
            sourceMap = _ref.sourceMap;

        _classCallCheck(this, CssDependency);

        var _this = _possibleConstructorReturn(this, (CssDependency.__proto__ || Object.getPrototypeOf(CssDependency)).call(this));

        _this.identifier = identifier;
        _this.identifierIndex = identifierIndex;
        _this.content = content;
        _this.media = media;
        _this.sourceMap = sourceMap;
        _this.context = context;
        return _this;
    }

    _createClass(CssDependency, [{
        key: 'getResourceIdentifier',
        value: function getResourceIdentifier() {
            return 'css-module-' + this.identifier + '-' + this.identifierIndex;
        }
    }]);

    return CssDependency;
}(_webpack2.default.Dependency);

var CssDependencyTemplate = function () {
    function CssDependencyTemplate() {
        _classCallCheck(this, CssDependencyTemplate);
    }

    _createClass(CssDependencyTemplate, [{
        key: 'apply',
        value: function apply() {}
    }]);

    return CssDependencyTemplate;
}();

var CssModule = function (_webpack$Module) {
    _inherits(CssModule, _webpack$Module);

    function CssModule(dependency) {
        _classCallCheck(this, CssModule);

        var _this2 = _possibleConstructorReturn(this, (CssModule.__proto__ || Object.getPrototypeOf(CssModule)).call(this, MODULE_TYPE, dependency.context));

        _this2.id = '';
        _this2._identifier = dependency.identifier;
        _this2._identifierIndex = dependency.identifierIndex;
        _this2.content = dependency.content;
        _this2.media = dependency.media;
        _this2.sourceMap = dependency.sourceMap;
        return _this2;
    }

    // no source() so webpack doesn't do add stuff to the bundle

    _createClass(CssModule, [{
        key: 'size',
        value: function size() {
            return this.content.length;
        }
    }, {
        key: 'identifier',
        value: function identifier() {
            return 'css ' + this._identifier + ' ' + this._identifierIndex;
        }
    }, {
        key: 'readableIdentifier',
        value: function readableIdentifier(requestShortener) {
            return 'css ' + requestShortener.shorten(this._identifier) + (this._identifierIndex ? ' (' + this._identifierIndex + ')' : '');
        }
    }, {
        key: 'nameForCondition',
        value: function nameForCondition() {
            var resource = this._identifier.split('!').pop();
            var idx = resource.indexOf('?');
            if (idx >= 0) return resource.substring(0, idx);
            return resource;
        }
    }, {
        key: 'updateCacheModule',
        value: function updateCacheModule(module) {
            this.content = module.content;
            this.media = module.media;
            this.sourceMap = module.sourceMap;
        }
    }, {
        key: 'needRebuild',
        value: function needRebuild() {
            return true;
        }
    }, {
        key: 'build',
        value: function build(options, compilation, resolver, fileSystem, callback) {
            this.buildInfo = {};
            this.buildMeta = {};
            callback();
        }
    }, {
        key: 'updateHash',
        value: function updateHash(hash) {
            _get(CssModule.prototype.__proto__ || Object.getPrototypeOf(CssModule.prototype), 'updateHash', this).call(this, hash);
            hash.update(this.content);
            hash.update(this.media || '');
            hash.update(this.sourceMap ? JSON.stringify(this.sourceMap) : '');
        }
    }]);

    return CssModule;
}(_webpack2.default.Module);

var CssModuleFactory = function () {
    function CssModuleFactory() {
        _classCallCheck(this, CssModuleFactory);
    }

    _createClass(CssModuleFactory, [{
        key: 'create',
        value: function create(_ref2, callback) {
            var _ref2$dependencies = _slicedToArray(_ref2.dependencies, 1),
                dependency = _ref2$dependencies[0];

            callback(null, new CssModule(dependency));
        }
    }]);

    return CssModuleFactory;
}();

var ExtractCssChunks = function () {
    function ExtractCssChunks(options) {
        _classCallCheck(this, ExtractCssChunks);

        this.options = Object.assign({
            filename: '[name].css'
        }, options);
        var _options = this.options,
            cssModules = _options.cssModules,
            reloadAll = _options.reloadAll;


        if (!this.options.chunkFilename) {
            var filename = this.options.filename;

            var hasName = filename.includes('[name]');
            var hasId = filename.includes('[id]');
            var hasChunkHash = filename.includes('[chunkhash]');
            // Anything changing depending on chunk is fine
            if (hasChunkHash || hasName || hasId) {
                this.options.chunkFilename = filename;
            } else {
                // Elsewise prefix '[id].' in front of the basename to make it changing
                this.options.chunkFilename = filename.replace(/(^|\/)([^/]*(?:\?|$))/, '$1[id].$2');
            }
        }

        this.hotLoaderObject = Object.assign({
            loader: hotLoader,
            options: {
                cssModules: false,
                reloadAll: false
            }
        }, {
            options: {
                cssModules: cssModules,
                reloadAll: reloadAll
            }
        });
    }

    _createClass(ExtractCssChunks, [{
        key: 'apply',
        value: function apply(compiler) {
            var _this3 = this;

            try {
                var isHOT = this.options.hot ? true : isHMR(compiler);

                if (isHOT && compiler.options.module && compiler.options.module.rules) {
                    compiler.options.module.rules = this.updateWebpackConfig(compiler.options.module.rules);
                }
            } catch (e) {
                throw new Error('Something went wrong: contact the author: ' + JSON.stringify(e));
            }

            compiler.hooks.thisCompilation.tap(pluginName, function (compilation) {
                compilation.hooks.normalModuleLoader.tap(pluginName, function (lc, m) {
                    var loaderContext = lc;
                    var module = m;
                    loaderContext[MODULE_TYPE] = function (content) {
                        if (!Array.isArray(content) && content != null) {
                            throw new Error('Exported value was not extracted as an array: ' + JSON.stringify(content));
                        }

                        var identifierCountMap = new Map();
                        var _iteratorNormalCompletion = true;
                        var _didIteratorError = false;
                        var _iteratorError = undefined;

                        try {
                            for (var _iterator = content[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                                var line = _step.value;

                                var count = identifierCountMap.get(line.identifier) || 0;
                                module.addDependency(new CssDependency(line, m.context, count));
                                identifierCountMap.set(line.identifier, count + 1);
                            }
                        } catch (err) {
                            _didIteratorError = true;
                            _iteratorError = err;
                        } finally {
                            try {
                                if (!_iteratorNormalCompletion && _iterator.return) {
                                    _iterator.return();
                                }
                            } finally {
                                if (_didIteratorError) {
                                    throw _iteratorError;
                                }
                            }
                        }
                    };
                });
                compilation.dependencyFactories.set(CssDependency, new CssModuleFactory());
                compilation.dependencyTemplates.set(CssDependency, new CssDependencyTemplate());
                compilation.mainTemplate.hooks.renderManifest.tap(pluginName, function (result, _ref3) {
                    var chunk = _ref3.chunk;

                    var renderedModules = Array.from(chunk.modulesIterable).filter(function (module) {
                        return module.type === MODULE_TYPE;
                    });
                    if (renderedModules.length > 0) {
                        result.push({
                            render: function render() {
                                return _this3.renderContentAsset(compilation, chunk, renderedModules, compilation.runtimeTemplate.requestShortener);
                            },
                            filenameTemplate: _this3.options.filename,
                            pathOptions: {
                                chunk: chunk,
                                contentHashType: MODULE_TYPE
                            },
                            identifier: pluginName + '.' + chunk.id,
                            hash: chunk.contentHash[MODULE_TYPE]
                        });
                    }
                });
                compilation.chunkTemplate.hooks.renderManifest.tap(pluginName, function (result, _ref4) {
                    var chunk = _ref4.chunk;

                    var renderedModules = Array.from(chunk.modulesIterable).filter(function (module) {
                        return module.type === MODULE_TYPE;
                    });
                    if (renderedModules.length > 0) {
                        result.push({
                            render: function render() {
                                return _this3.renderContentAsset(compilation, chunk, renderedModules, compilation.runtimeTemplate.requestShortener);
                            },
                            filenameTemplate: _this3.options.chunkFilename,
                            pathOptions: {
                                chunk: chunk,
                                contentHashType: MODULE_TYPE
                            },
                            identifier: pluginName + '.' + chunk.id,
                            hash: chunk.contentHash[MODULE_TYPE]
                        });
                    }
                });
                compilation.mainTemplate.hooks.hashForChunk.tap(pluginName, function (hash, chunk) {
                    var chunkFilename = _this3.options.chunkFilename;

                    if (REGEXP_CHUNKHASH.test(chunkFilename)) {
                        hash.update(JSON.stringify(chunk.getChunkMaps(true).hash));
                    }
                    if (REGEXP_CONTENTHASH.test(chunkFilename)) {
                        hash.update(JSON.stringify(chunk.getChunkMaps(true).contentHash[MODULE_TYPE] || {}));
                    }
                    if (REGEXP_NAME.test(chunkFilename)) {
                        hash.update(JSON.stringify(chunk.getChunkMaps(true).name));
                    }
                });
                compilation.hooks.contentHash.tap(pluginName, function (chunk) {
                    var outputOptions = compilation.outputOptions;
                    var hashFunction = outputOptions.hashFunction,
                        hashDigest = outputOptions.hashDigest,
                        hashDigestLength = outputOptions.hashDigestLength;

                    var hash = createHash(hashFunction);
                    var _iteratorNormalCompletion2 = true;
                    var _didIteratorError2 = false;
                    var _iteratorError2 = undefined;

                    try {
                        for (var _iterator2 = chunk.modulesIterable[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
                            var m = _step2.value;

                            if (m.type === MODULE_TYPE) {
                                m.updateHash(hash);
                            }
                        }
                    } catch (err) {
                        _didIteratorError2 = true;
                        _iteratorError2 = err;
                    } finally {
                        try {
                            if (!_iteratorNormalCompletion2 && _iterator2.return) {
                                _iterator2.return();
                            }
                        } finally {
                            if (_didIteratorError2) {
                                throw _iteratorError2;
                            }
                        }
                    }

                    var contentHash = chunk.contentHash;

                    contentHash[MODULE_TYPE] = hash.digest(hashDigest).substring(0, hashDigestLength);
                });
                var mainTemplate = compilation.mainTemplate;

                mainTemplate.hooks.localVars.tap(pluginName, function (source, chunk) {
                    var chunkMap = _this3.getCssChunkObject(chunk);
                    if (Object.keys(chunkMap).length > 0) {
                        return Template.asString([source, '', '// object to store loaded CSS chunks', 'var installedCssChunks = {', Template.indent(chunk.ids.map(function (id) {
                            return JSON.stringify(id) + ': 0';
                        }).join(',\n')), '}']);
                    }
                    return source;
                });
                mainTemplate.hooks.requireEnsure.tap(pluginName, function (source, chunk, hash) {
                    var chunkMap = _this3.getCssChunkObject(chunk);
                    if (Object.keys(chunkMap).length > 0) {
                        var chunkMaps = chunk.getChunkMaps();
                        var crossOriginLoading = mainTemplate.outputOptions.crossOriginLoading;

                        var linkHrefPath = mainTemplate.getAssetPath(JSON.stringify(_this3.options.chunkFilename), {
                            hash: '" + ' + mainTemplate.renderCurrentHashCode(hash) + ' + "',
                            hashWithLength: function hashWithLength(length) {
                                return '" + ' + mainTemplate.renderCurrentHashCode(hash, length) + ' + "';
                            },
                            chunk: {
                                id: '" + chunkId + "',
                                hash: '" + ' + JSON.stringify(chunkMaps.hash) + '[chunkId] + "',
                                hashWithLength: function hashWithLength(length) {
                                    var shortChunkHashMap = Object.create(null);
                                    var _iteratorNormalCompletion3 = true;
                                    var _didIteratorError3 = false;
                                    var _iteratorError3 = undefined;

                                    try {
                                        for (var _iterator3 = Object.keys(chunkMaps.hash)[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
                                            var chunkId = _step3.value;

                                            if (typeof chunkMaps.hash[chunkId] === 'string') {
                                                shortChunkHashMap[chunkId] = chunkMaps.hash[chunkId].substring(0, length);
                                            }
                                        }
                                    } catch (err) {
                                        _didIteratorError3 = true;
                                        _iteratorError3 = err;
                                    } finally {
                                        try {
                                            if (!_iteratorNormalCompletion3 && _iterator3.return) {
                                                _iterator3.return();
                                            }
                                        } finally {
                                            if (_didIteratorError3) {
                                                throw _iteratorError3;
                                            }
                                        }
                                    }

                                    return '" + ' + JSON.stringify(shortChunkHashMap) + '[chunkId] + "';
                                },

                                contentHash: _defineProperty({}, MODULE_TYPE, '" + ' + JSON.stringify(chunkMaps.contentHash[MODULE_TYPE]) + '[chunkId] + "'),
                                contentHashWithLength: _defineProperty({}, MODULE_TYPE, function (length) {
                                    var shortContentHashMap = {};
                                    var contentHash = chunkMaps.contentHash[MODULE_TYPE];
                                    var _iteratorNormalCompletion4 = true;
                                    var _didIteratorError4 = false;
                                    var _iteratorError4 = undefined;

                                    try {
                                        for (var _iterator4 = Object.keys(contentHash)[Symbol.iterator](), _step4; !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true) {
                                            var chunkId = _step4.value;

                                            if (typeof contentHash[chunkId] === 'string') {
                                                shortContentHashMap[chunkId] = contentHash[chunkId].substring(0, length);
                                            }
                                        }
                                    } catch (err) {
                                        _didIteratorError4 = true;
                                        _iteratorError4 = err;
                                    } finally {
                                        try {
                                            if (!_iteratorNormalCompletion4 && _iterator4.return) {
                                                _iterator4.return();
                                            }
                                        } finally {
                                            if (_didIteratorError4) {
                                                throw _iteratorError4;
                                            }
                                        }
                                    }

                                    return '" + ' + JSON.stringify(shortContentHashMap) + '[chunkId] + "';
                                }),
                                name: '" + (' + JSON.stringify(chunkMaps.name) + '[chunkId]||chunkId) + "'
                            },
                            contentHashType: MODULE_TYPE
                        });
                        return Template.asString([source, '', '// ' + pluginName + ' CSS loading', 'var cssChunks = ' + JSON.stringify(chunkMap) + ';', 'if(installedCssChunks[chunkId]) promises.push(installedCssChunks[chunkId]);', 'else if(installedCssChunks[chunkId] !== 0 && cssChunks[chunkId]) {', Template.indent(['promises.push(installedCssChunks[chunkId] = new Promise(function(resolve, reject) {', Template.indent(['var href = ' + linkHrefPath + ';', 'var fullhref = ' + mainTemplate.requireFn + '.p + href;', 'var existingLinkTags = document.getElementsByTagName("link");', 'for(var i = 0; i < existingLinkTags.length; i++) {', Template.indent(['var tag = existingLinkTags[i];', 'var dataHref = tag.getAttribute("data-href") || tag.getAttribute("href");', 'if(tag.rel === "stylesheet" && (dataHref === href || dataHref === fullhref)) return resolve();']), '}', 'var existingStyleTags = document.getElementsByTagName("style");', 'for(var i = 0; i < existingStyleTags.length; i++) {', Template.indent(['var tag = existingStyleTags[i];', 'var dataHref = tag.getAttribute("data-href");', 'if(dataHref === href || dataHref === fullhref) return resolve();']), '}', 'var linkTag = document.createElement("link");', 'linkTag.rel = "stylesheet";', 'linkTag.type = "text/css";', 'linkTag.onload = resolve;', 'linkTag.onerror = function(event) {', Template.indent(['var request = event && event.target && event.target.src || fullhref;', 'var err = new Error("Loading CSS chunk " + chunkId + " failed.\\n(" + request + ")");', 'err.request = request;', 'delete installedCssChunks[chunkId]', 'linkTag.parentNode.removeChild(linkTag)', 'reject(err);']), '};', 'linkTag.href = fullhref;', crossOriginLoading ? Template.asString(["if (linkTag.href.indexOf(window.location.origin + '/') !== 0) {", Template.indent('linkTag.crossOrigin = ' + JSON.stringify(crossOriginLoading) + ';'), '}']) : '', 'var head = document.getElementsByTagName("head")[0];', 'head.appendChild(linkTag);']), '}).then(function() {', Template.indent(['installedCssChunks[chunkId] = 0;']), '}));']), '}']);
                    }
                    return source;
                });
            });
        }
    }, {
        key: 'traverseDepthFirst',
        value: function traverseDepthFirst(root, visit) {
            var nodesToVisit = [root];

            while (nodesToVisit.length > 0) {
                var currentNode = nodesToVisit.shift();

                if (currentNode !== null && (typeof currentNode === 'undefined' ? 'undefined' : _typeof(currentNode)) === 'object') {
                    var children = Object.values(currentNode);
                    nodesToVisit = [].concat(_toConsumableArray(children), _toConsumableArray(nodesToVisit));
                }

                visit(currentNode);
            }
        }
    }, {
        key: 'updateWebpackConfig',
        value: function updateWebpackConfig(rulez) {
            var _this4 = this;

            return rulez.reduce(function (rules, rule) {
                _this4.traverseDepthFirst(rule, function (node) {
                    if (node && node.use && Array.isArray(node.use)) {
                        var isExtractCss = node.use.some(function (l) {
                            var needle = l.loader || l;
                            if (typeof l === 'function') {
                                return false;
                            }
                            return needle.includes(pluginName);
                        });
                        if (isExtractCss) {
                            node.use.unshift(_this4.hotLoaderObject);
                        }
                    }
                    if (node && node.loader && Array.isArray(node.loader)) {
                        var _isExtractCss = node.loader.some(function (l) {
                            var needle = l.loader || l;
                            if (typeof l === 'function') {
                                return false;
                            }
                            return needle.includes(pluginName);
                        });
                        if (_isExtractCss) {
                            node.loader.unshift(_this4.hotLoaderObject);
                        }
                    }
                });

                rules.push(rule);

                return rules;
            }, []);
        }
    }, {
        key: 'getCssChunkObject',
        value: function getCssChunkObject(mainChunk) {
            var obj = {};
            var _iteratorNormalCompletion5 = true;
            var _didIteratorError5 = false;
            var _iteratorError5 = undefined;

            try {
                for (var _iterator5 = mainChunk.getAllAsyncChunks()[Symbol.iterator](), _step5; !(_iteratorNormalCompletion5 = (_step5 = _iterator5.next()).done); _iteratorNormalCompletion5 = true) {
                    var chunk = _step5.value;
                    var _iteratorNormalCompletion6 = true;
                    var _didIteratorError6 = false;
                    var _iteratorError6 = undefined;

                    try {
                        for (var _iterator6 = chunk.modulesIterable[Symbol.iterator](), _step6; !(_iteratorNormalCompletion6 = (_step6 = _iterator6.next()).done); _iteratorNormalCompletion6 = true) {
                            var module = _step6.value;

                            if (module.type === MODULE_TYPE) {
                                obj[chunk.id] = 1;
                                break;
                            }
                        }
                    } catch (err) {
                        _didIteratorError6 = true;
                        _iteratorError6 = err;
                    } finally {
                        try {
                            if (!_iteratorNormalCompletion6 && _iterator6.return) {
                                _iterator6.return();
                            }
                        } finally {
                            if (_didIteratorError6) {
                                throw _iteratorError6;
                            }
                        }
                    }
                }
            } catch (err) {
                _didIteratorError5 = true;
                _iteratorError5 = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion5 && _iterator5.return) {
                        _iterator5.return();
                    }
                } finally {
                    if (_didIteratorError5) {
                        throw _iteratorError5;
                    }
                }
            }

            return obj;
        }
    }, {
        key: 'renderContentAsset',
        value: function renderContentAsset(compilation, chunk, modules, requestShortener) {
            var usedModules = void 0;

            var _chunk$groupsIterable = _slicedToArray(chunk.groupsIterable, 1),
                chunkGroup = _chunk$groupsIterable[0];

            if (typeof chunkGroup.getModuleIndex2 === 'function') {
                // Store dependencies for modules
                var moduleDependencies = new Map(modules.map(function (m) {
                    return [m, new Set()];
                }));

                // Get ordered list of modules per chunk group
                // This loop also gathers dependencies from the ordered lists
                // Lists are in reverse order to allow to use Array.pop()
                var modulesByChunkGroup = Array.from(chunk.groupsIterable, function (cg) {
                    var sortedModules = modules.map(function (m) {
                        return {
                            module: m,
                            index: cg.getModuleIndex2(m)
                        };
                    }).filter(function (item) {
                        return item.index !== undefined;
                    }).sort(function (a, b) {
                        return b.index - a.index;
                    }).map(function (item) {
                        return item.module;
                    });
                    for (var i = 0; i < sortedModules.length; i++) {
                        var set = moduleDependencies.get(sortedModules[i]);
                        for (var j = i + 1; j < sortedModules.length; j++) {
                            set.add(sortedModules[j]);
                        }
                    }

                    return sortedModules;
                });

                // set with already included modules in correct order
                usedModules = new Set();

                var unusedModulesFilter = function unusedModulesFilter(m) {
                    return !usedModules.has(m);
                };

                while (usedModules.size < modules.length) {
                    var success = false;
                    var bestMatch = void 0;
                    var bestMatchDeps = void 0;
                    // get first module where dependencies are fulfilled
                    var _iteratorNormalCompletion7 = true;
                    var _didIteratorError7 = false;
                    var _iteratorError7 = undefined;

                    try {
                        for (var _iterator7 = modulesByChunkGroup[Symbol.iterator](), _step7; !(_iteratorNormalCompletion7 = (_step7 = _iterator7.next()).done); _iteratorNormalCompletion7 = true) {
                            var list = _step7.value;

                            // skip and remove already added modules
                            while (list.length > 0 && usedModules.has(list[list.length - 1])) {
                                list.pop();
                            }

                            // skip empty lists
                            if (list.length !== 0) {
                                var module = list[list.length - 1];
                                var deps = moduleDependencies.get(module);
                                // determine dependencies that are not yet included
                                var failedDeps = Array.from(deps).filter(unusedModulesFilter);

                                // store best match for fallback behavior
                                if (!bestMatchDeps || bestMatchDeps.length > failedDeps.length) {
                                    bestMatch = list;
                                    bestMatchDeps = failedDeps;
                                }
                                if (failedDeps.length === 0) {
                                    // use this module and remove it from list
                                    usedModules.add(list.pop());
                                    success = true;
                                    break;
                                }
                            }
                        }
                    } catch (err) {
                        _didIteratorError7 = true;
                        _iteratorError7 = err;
                    } finally {
                        try {
                            if (!_iteratorNormalCompletion7 && _iterator7.return) {
                                _iterator7.return();
                            }
                        } finally {
                            if (_didIteratorError7) {
                                throw _iteratorError7;
                            }
                        }
                    }

                    if (!success) {
                        // no module found => there is a conflict
                        // use list with fewest failed deps
                        // and emit a warning
                        var fallbackModule = bestMatch.pop();
                        compilation.warnings.push(new Error('chunk ' + (chunk.name || chunk.id) + ' [extract-css-chunks-plugin]\n' + 'Conflicting order between:\n' + (' * ' + fallbackModule.readableIdentifier(requestShortener) + '\n') + ('' + bestMatchDeps.map(function (m) {
                            return ' * ' + m.readableIdentifier(requestShortener);
                        }).join('\n'))));
                        usedModules.add(fallbackModule);
                    }
                }
            } else {
                // fallback for older webpack versions
                // (to avoid a breaking change)
                // TODO remove this in next mayor version
                // and increase minimum webpack version to 4.12.0
                modules.sort(function (a, b) {
                    return a.index2 - b.index2;
                });
                usedModules = modules;
            }
            var source = new ConcatSource();
            var externalsSource = new ConcatSource();
            var _iteratorNormalCompletion8 = true;
            var _didIteratorError8 = false;
            var _iteratorError8 = undefined;

            try {
                for (var _iterator8 = usedModules[Symbol.iterator](), _step8; !(_iteratorNormalCompletion8 = (_step8 = _iterator8.next()).done); _iteratorNormalCompletion8 = true) {
                    var m = _step8.value;

                    if (/^@import url/.test(m.content)) {
                        // HACK for IE
                        // http://stackoverflow.com/a/14676665/1458162
                        var content = m.content;

                        if (m.media) {
                            // insert media into the @import
                            // this is rar
                            // TODO improve this and parse the CSS to support multiple medias
                            content = content.replace(/;|\s*$/, m.media);
                        }
                        externalsSource.add(content);
                        externalsSource.add('\n');
                    } else {
                        if (m.media) {
                            source.add('@media ' + m.media + ' {\n');
                        }
                        if (m.sourceMap) {
                            source.add(new SourceMapSource(m.content, m.readableIdentifier(requestShortener), m.sourceMap));
                        } else {
                            source.add(new OriginalSource(m.content, m.readableIdentifier(requestShortener)));
                        }
                        source.add('\n');
                        if (m.media) {
                            source.add('}\n');
                        }
                    }
                }
            } catch (err) {
                _didIteratorError8 = true;
                _iteratorError8 = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion8 && _iterator8.return) {
                        _iterator8.return();
                    }
                } finally {
                    if (_didIteratorError8) {
                        throw _iteratorError8;
                    }
                }
            }

            return new ConcatSource(externalsSource, source);
        }
    }]);

    return ExtractCssChunks;
}();

ExtractCssChunks.loader = require.resolve('./loader');
ExtractCssChunks.hotLoader = require.resolve('./hotLoader');

exports.default = ExtractCssChunks;